package com.polarsparc.cxf.jaxws.generated;

import java.lang.Math;

import java.util.logging.Logger;

/**
 * This class was generated by Apache CXF 2.5.1
 * 2012-01-06T22:30:30.310-05:00
 * Generated source version: 2.5.1
 * 
 */

@javax.jws.WebService(
                      serviceName = "MonthlyMortgageCalculatorService",
                      portName = "MonthlyMortgageCalculatorPort",
                      targetNamespace = "http://polarsparc.com/",
                      wsdlLocation = "/home/bswamina/Projects/Java/CXF-WebServices/resources/MonthlyMortgageCalculator.wsdl",
                      endpointInterface = "com.polarsparc.cxf.jaxws.generated.MonthlyMortgageCalculator")
                      
public class MonthlyMortgageCalculatorImpl implements MonthlyMortgageCalculator {

    private static final Logger LOG = Logger.getLogger(MonthlyMortgageCalculatorImpl.class.getName());

    /* (non-Javadoc)
     * @see com.polarsparc.cxf.jaxws.generated.MonthlyMortgageCalculator#calculateMonthlyMortgage(com.polarsparc.cxf.jaxws.generated.MonthlyMortgageRequest  parameters )*
     */
    public com.polarsparc.cxf.jaxws.generated.MonthlyMortgageResponse calculateMonthlyMortgage(MonthlyMortgageRequest parameters) { 
        LOG.info("Executing operation calculateMonthlyMortgage");
        System.out.println(parameters);
        try {
            com.polarsparc.cxf.jaxws.generated.MonthlyMortgageResponse _return = (new ObjectFactory()).createMonthlyMortgageResponse();
            _return.payment = MonthlyMortgagePayment(parameters);
            return _return;
        } catch (java.lang.Exception ex) {
            ex.printStackTrace();
            throw new RuntimeException(ex);
        }
    }

    /*
     * The formula for computing the monthly mortgage payment (M) is: P * J / (1 - (1 / (1 + J)^N))
     * where:
     *     P is the Mortgage Amount
     *     J is the monthly interest. If I is the interest per annum, then J = I / 12 * 100
     *     N is the loan period in months. If Y is the no of years,  then N = Y * 12
     */
    private double MonthlyMortgagePayment(MonthlyMortgageRequest parameters) throws Exception {
    	double N = parameters.years * 12;
    	double P = parameters.amount;
    	double J = parameters.rate / 1200;
    	return P * (J / (1 - (1/Math.pow(1+J, N))));
    }
}
