package com.polarsparc.cxf.jaxws.standalone;

import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.ws.Service;

public class SimpleInterestCalculatorClient {
	public static void main(String[] args) {
		try {
			if (args.length != 3) {
				System.out.printf("Usage: java %s <months> <amount> <rate>\n", SimpleInterestCalculatorClient.class.getName());
				System.exit(1);
			}
			
			QName serviceName = new QName("http://standalone.jaxws.cxf.polarsparc.com/", "SimpleInterestCalculatorImplService");
			
			String wsdl = "http://localhost:8080/SimpleInterestCalculator?wsdl";
			
			Service service = Service.create(new URL(wsdl), serviceName);
			
			QName portName = new QName("http://standalone.jaxws.cxf.polarsparc.com/", "SimpleInterestCalculatorImplPort");
			
			SimpleInterestCalculator client = service.getPort(portName, SimpleInterestCalculator.class);
			
			double interest = client.calculateSimpleInterest(Integer.valueOf(args[0]), Double.valueOf(args[1]), Double.valueOf(args[2]));
			
			System.out.printf("Amount: %s, Rate: %s, Months: %s, Interest: %.2f\n", args[1], args[2], args[0], interest);
		}
		catch (Exception ex) {
			ex.printStackTrace(System.err);
		}
	}
}
