package com.polarsparc.cxf.jaxws.standalone;

import javax.jws.WebService;

@WebService(name="SimpleInterestCalculator",
	    targetNamespace="http://polarsparc.com/",
	    serviceName="SimpleInterestCalculatorService",
	    portName="SimpleInterestCalculatorPort")
public class SimpleInterestCalculatorImpl2 implements SimpleInterestCalculator2 {
	@Override
	public double calculateSimpleInterest2(int months, double amount, double rate)
		throws Exception {
		validateParams(months, amount, rate);
		
		double interest = (amount * rate * months)/(12 * 100);
		
		return interest;
	}
	
	private void validateParams(int months, double amount, double rate)
		throws Exception {
		if (months <= 0) {
			throw new Exception("Invalid parameter: months");
		}
		
		if (amount <= 0.0) {
			throw new Exception("Invalid parameter: amount");
		}
		
		if (rate <= 0.0) {
			throw new Exception("Invalid parameter: rate");
		}
	}
}
