package com.polarsparc.cxf.jaxws.standalone;

import javax.jws.WebService;

@WebService(name="SimpleInterestCalculator",
	    targetNamespace="http://polarsparc.com/",
	    serviceName="SimpleInterestCalculatorService",
	    portName="SimpleInterestCalculatorPort")
public class SimpleInterestCalculatorImpl3 implements SimpleInterestCalculator3 {
	@Override
	public double calculateSimpleInterest3(SimpleInterestDTO dto)
		throws Exception {
		validateParams(dto);
		
		double interest = (dto.getAmount() * dto.getRate() * dto.getMonths())/(12 * 100);
		
		return interest;
	}
	
	private void validateParams(SimpleInterestDTO dto)
		throws Exception {
		if (dto.getMonths() <= 0) {
			throw new Exception("Invalid parameter: months");
		}
		
		if (dto.getAmount() <= 0.0) {
			throw new Exception("Invalid parameter: amount");
		}
		
		if (dto.getRate() <= 0.0) {
			throw new Exception("Invalid parameter: rate");
		}
	}
}
