package com.polarsparc.cxf.jaxws.webapp;

import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.ws.Service;

import com.polarsparc.cxf.jaxws.generated.MonthlyMortgageCalculator;
import com.polarsparc.cxf.jaxws.generated.MonthlyMortgageRequest;
import com.polarsparc.cxf.jaxws.generated.MonthlyMortgageResponse;

public class MonthlyMortgageCalculatorClient {
	public static void main(String[] args) {
		try {
			if (args.length != 3) {
				System.out.printf("Usage: java %s <years> <amount> <rate>\n", MonthlyMortgageCalculatorClient.class.getName());
				System.exit(1);
			}
			
			QName serviceName = new QName("http://polarsparc.com/", "MonthlyMortgageCalculatorService");
			
			String wsdl = "http://localhost:8080/CXFWebServices/services/MonthlyMortgageCalculator?wsdl";
			
			Service service = Service.create(new URL(wsdl), serviceName);
			
			QName portName = new QName("http://polarsparc.com/", "MonthlyMortgageCalculatorPort");
			
			MonthlyMortgageCalculator client = service.getPort(portName, MonthlyMortgageCalculator.class);
			
			MonthlyMortgageRequest request = new MonthlyMortgageRequest();
			request.setYears(Integer.valueOf(args[0]));
			request.setAmount(Double.valueOf(args[1]));
			request.setRate(Double.valueOf(args[2]));
			
			MonthlyMortgageResponse response = client.calculateMonthlyMortgage(request);
			
			System.out.printf("Amount: %s, Rate: %s, Years: %s, Payment: %.2f\n", args[1], args[2], args[0], response.getPayment());
		}
		catch (Exception ex) {
			ex.printStackTrace(System.err);
		}
	}
}
