package com.polarsparc.cxf.jaxws.webapp;

import org.springframework.context.support.ClassPathXmlApplicationContext;

public class SimpleInterestCalculatorClient5 {
	public static void main(String[] args) {
		try {
			if (args.length != 4) {
				System.out.printf("Usage: java %s <config> <months> <amount> <rate>\n", SimpleInterestCalculatorClient5.class.getName());
				System.exit(1);
			}
			
			ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext(args[0]);
			
			SimpleInterestCalculator4 client = (SimpleInterestCalculator4) context.getBean("interestClient");
			
			double interest = client.calculateSimpleInterest4(Integer.valueOf(args[1]), Double.valueOf(args[2]), Double.valueOf(args[3]));
			
			System.out.printf("Amount: %s, Rate: %s, Months: %s, Interest: %.2f\n", args[2], args[3], args[1], interest);
		}
		catch (Exception ex) {
			ex.printStackTrace(System.err);
		}
	}
}
